﻿using System;
using System.Collections.Generic;

namespace LukaFilipic_PI
{
    public abstract class Osoba : IComparable<Osoba>
    {
        private readonly int id;
        private static int counter = 1000;
        public Osoba(string oib, string ime, string prezime)
        {
            id = counter;
            counter += 10;
            Ime = ime;
            Prezime = prezime;
            OIB = oib;
        }

        private string oib;

        public string OIB {
            get => oib;
            private set
            {
                if (value.Length != 11)
                {
                    throw new Exception("OIB mora imati 11 znakova!");
                }
                //if (Math.Abs((int)value[9] - (int)value[10]) != (int)value[1]) {
                //    throw new System.Exception("Razlika predzadnjeg i zadnjeg broja mora biti jednaka drugom broju");
                //}
                oib = value;
            }
        }

        public string Ime { get; set; }
        public string Prezime { get; set; }

        public override string ToString()
        {
            return $"|{id}| |{oib}| {Ime} {Prezime}";
        }

        public override bool Equals(object obj)
        {
            return obj is Osoba osoba &&
                   oib == osoba.oib;
        }

        public override int GetHashCode()
        {
            return -997221795 + EqualityComparer<string>.Default.GetHashCode(oib);
        }

        public int CompareTo(Osoba other) => this.id.CompareTo(other.id);
    }
}